%*define (Process)
(
        PUSH    ACC
        MOV     LOp, #10
        LCALL   iMUL
        POP     ACC
        MOV     LOp,A 
        LCALL   iADD
)

        NAME    DCBMOD
;--Converts String in Record into Binary
;--- Uses external subprogram iADD, iMUL !!!!!!

        PUBLIC  iDCB             ; for assembler
        PUBLIC  DCB0, ?DCB0?Byte ; for PLMs
        PUBLIC  DCB1, ?DCB1?Byte
        PUBLIC  DCB2, ?DCB2?Byte
        PUBLIC  DCB3, ?DCB3?Byte
        EXTRN   CODE(iDIV)

?DCB0?Byte EQU 1;uses bank 0!  Start from R1 etc.
?DCB1?Byte EQU 9;uses bank 1!  Start from R1 etc.
?DCB2?Byte EQU 17;uses bank 2!  Start from R1 etc.
?DCB3?Byte EQU 25;uses bank 3!  Start from R1 etc.

Index	EQU	R0
RecPtr  EQU     R1
HOp     EQU     R2; Work Operand
LOp     EQU     R3
ByteCounter     EQU     DPL

        Math2   SEGMENT CODE
        RSEG    Math2
iDCB:
DCB0:
DCB1:
DCB2:
DCB3:
;----- Move Record to Stack and Clear
	MOV	A, RecPtr
	ADD	A,#3
        MOV     RecPtr,A
	MOV	ByteCounter,#4
M0loop: CLR     A
        XCH     A, @RecPtr
        PUSH    ACC
        DEC     RecPtr
	DJNZ	ByteCounter, M0loop
        INC     RecPtr






        CLR     A
        MOV     @RecPtr, A ;--- Clear high word
        INC     RecPtr
        MOV     @RecPtr, A
        DEC     RecPtr
	MOV	Index, A
DCBloop:
	MOV	DPTR, #Divider	;-------Get Divider
	MOV	A, Index
	INC	Index
	MOVC	A, @A+DPTR
	MOV	HOp, A
	MOV	A, Index
	INC	Index
	MOVC	A, @A+DPTR
	MOV	LOp, A

	MOV	A, Index
	PUSH	ACC	;---- Save Index

        LCALL   iDIV
	POP	ACC 	;---Restore Index
	MOV	Index, A

        MOV     A, AtLowByte; --- Get Char
        MOV     RecPtr, A
        MOV     A, @RecPtr
        ORL     A, #30H
        PUSH    ACC

;-----W1, W0 ---> Rec.1  Rec.0 with RecPtr retreive
        MOV     A, W0
        MOV     @RecPtr, A
        DEC     RecPtr
        MOV     A, W1
        MOV     @RecPtr, A
        DEC     RecPtr
        DEC     RecPtr

        CJNE    Index, #8, DCBloop

        MOV     A, W0
        ORL     A, #30H
        PUSH    ACC
        ;----- At Low Byte of Record
        MOV     A, AtLowByte
        MOV     RecPtr, A
        ;-------Move chars to Record
        MOV     Index, #4
Bloop:  POP     ACC
        MOV     @RecPtr, A
        DEC     RecPtr
        DJNZ    Index, Bloop
        POP     ACC
        RET

        END
