        NAME    CMPMOD
;-------- COMPARE operations follow.

        PUBLIC   iLess, iEqul, iGreater; for assembler
        PUBLIC   Less0, ?Less0?Byte    ; for PLMs
        PUBLIC   Less1, ?Less1?Byte
        PUBLIC   Less2, ?Less2?Byte
        PUBLIC   Less3, ?Less3?Byte
        PUBLIC   Equl0, ?Equl0?Byte
        PUBLIC   Equl1, ?Equl1?Byte
        PUBLIC   Equl2, ?Equl2?Byte
        PUBLIC   Equl3, ?Equl3?Byte
        PUBLIC   Greater0, ?Greater0?Byte
        PUBLIC   Greater1, ?Greater1?Byte
        PUBLIC   Greater2, ?Greater2?Byte
        PUBLIC   Greater3, ?Greater3?Byte

?Less0?Byte EQU 1;uses bank 0!  Start from R1 etc.
?Less1?Byte EQU 9;uses bank 1!  Start from R1 etc.
?Less2?Byte EQU 17;uses bank 2!  Start from R1 etc.
?Less3?Byte EQU 25;uses bank 3!  Start from R1 etc.
?Equl0?Byte EQU 1;uses bank 0!  Start from R1 etc.
?Equl1?Byte EQU 9;uses bank 1!  Start from R1 etc.
?Equl2?Byte EQU 17;uses bank 2!  Start from R1 etc.
?Equl3?Byte EQU 25;uses bank 3!  Start from R1 etc.
?Greater0?Byte EQU 1;uses bank 0!  Start from R1 etc.
?Greater1?Byte EQU 9;uses bank 1!  Start from R1 etc.
?Greater2?Byte EQU 17;uses bank 2!  Start from R1 etc.
?Greater3?Byte EQU 25;uses bank 3!  Start from R1 etc.

RecPtr  EQU     R1

        Math2   SEGMENT CODE
        RSEG    Math2
iLess:;------CY= Lo(Accumultor) < Hi(Accumultor)
Less0:
Less1:
Less2:
Less3:
	MOV	A, RecPtr; Calculate Lo - Hi
	ADD	A, #3
	MOV	RecPtr, A
	CLR	CY
        MOV     A, @RecPtr
	DEC	RecPtr
	DEC	RecPtr
        SUBB    A, @RecPtr
	INC	RecPtr
	MOV	A, @RecPtr
	DEC	RecPtr
	DEC	RecPtr
        SUBB    A, @RecPtr
        RET

iGreater:;------CY= Lo(Accumultor) > Hi(Accumultor)
Greater0:
Greater1:
Greater2:
Greater3:
	INC	RecPtr; Calculate  Hi - Lo
	CLR	CY
        MOV     A, @RecPtr
	INC	RecPtr
	INC	RecPtr
        SUBB    A, @RecPtr
	DEC	RecPtr
	DEC	RecPtr
	DEC	RecPtr
	MOV	A, @RecPtr
	INC	RecPtr
	INC	RecPtr
        SUBB    A, @RecPtr
	DEC	RecPtr
	DEC	RecPtr
        RET

iEqul:;------CY= Lo(Accumultor) = Hi(Accumultor)
Equl0:
Equl1:
Equl2:
Equl3:
	MOV	A, RecPtr; Calculate Lo - Hi
	ADD	A, #3
	MOV	RecPtr, A
	CLR	CY
        MOV     A, @RecPtr
	DEC	RecPtr
	DEC	RecPtr
        SUBB    A, @RecPtr
        CJNE    A,#0,Esc
	CLR	CY
	INC	RecPtr
	MOV	A, @RecPtr
	DEC	RecPtr
	DEC	RecPtr
        SUBB    A, @RecPtr
        CJNE    A,#0,Esc
        SETB    CY
	RET
Esc:	CLR	CY
	RET

        END
