        NAME    AddMOD
;-------- ADD, SUB operations follow.

        PUBLIC  iADD, iSUB
        PUBLIC  ADD0, SUB0, ?ADD0?Byte, ?SUB0?Byte
        PUBLIC  ADD1, SUB1, ?ADD1?Byte, ?SUB1?Byte
        PUBLIC  ADD2, SUB2, ?ADD2?Byte, ?SUB2?Byte
        PUBLIC  ADD3, SUB3, ?ADD3?Byte, ?SUB3?Byte

?ADD0?Byte EQU  1;Start from R1 of bank_0
?SUB0?Byte EQU  1
?ADD1?Byte EQU  9;Start from R1 of bank_1
?SUB1?Byte EQU  9
?ADD2?Byte EQU  17;Start from R1 of bank_2
?SUB2?Byte EQU  17
?ADD3?Byte EQU  25;Start from R1 of bank_3
?SUB3?Byte EQU  25

RecPtr  EQU     R1
HOp     EQU     R2
LOp     EQU     R3

        Math2   SEGMENT CODE;-----------------
        RSEG    Math2
AtLowByte:
;----- Skip to the low accumulator byte and return it
        INC     RecPTR
        INC     RecPTR
        INC     RecPTR
        MOV     A,@RecPTR
        RET
iADD:;---------  Accumultor = Accumultor + Operand
ADD0:
ADD1:
ADD2:
ADD3:
        LCALL   AtLowByte
        ADD     A, LOp
        MOV     @RecPTR, A
        DEC     RecPTR
        MOV     A, @RecPTR
        ADDC    A, HOp
        MOV     @RecPTR, A
        DEC     RecPTR
        MOV     A, @RecPTR
        ADDC    A, #0
        MOV     @RecPTR, A
        DEC     RecPTR
        MOV     A, @RecPTR
        ADDC    A, #0
        MOV     @RecPTR, A
        RET

iSUB:;---- Accumultor = Accumultor -Operand, CY= borrow
SUB0:
SUB1:
SUB2:
SUB3:
        LCALL   AtLowByte
        CLR     CY
        SUBB    A, LOp
        MOV     @RecPTR, A
        DEC     RecPTR
        MOV     A, @RecPTR
        SUBB    A, HOp
        MOV     @RecPTR, A
        DEC     RecPTR
        MOV     A, @RecPTR
        SUBB    A, #0
        MOV     @RecPTR, A
        DEC     RecPTR
        MOV     A, @RecPTR
        SUBB    A, #0
        MOV     @RecPTR, A
        RET

        END
