;------- Fast BCD conversion without external calls!!!!

%*define (Convert(Where))
(
        ANL     A,#0FH
        ORL     A,#30H
        MOV     %Where,A
)

        NAME    BCDMOD
;-------- BCD operation follows.

        PUBLIC  iBCD             ; for assembler
        PUBLIC  BCD0, ?BCD0?Byte ; for PLMs
        PUBLIC  BCD1, ?BCD1?Byte
        PUBLIC  BCD2, ?BCD2?Byte
        PUBLIC  BCD3, ?BCD3?Byte


?BCD0?Byte EQU 1;uses bank 0!  Start from R1 etc.
?BCD1?Byte EQU 9;uses bank 1!  Start from R1 etc.
?BCD2?Byte EQU 17;uses bank 2!  Start from R1 etc.
?BCD3?Byte EQU 25;uses bank 3!  Start from R1 etc.

RecPtr  EQU     R1
W2	EQU	R5
W1      EQU     R6
W0      EQU     R7
Wptr    EQU     R0
BitCounter      EQU     R2
RecLowByte      EQU     R4

        Math2   SEGMENT CODE
        RSEG    Math2
TblStart: DB    00H,00H,01H, 00H,00H,02H
	  DB	00H,00H,04H, 00H,00H,08H
          DB    00H,00H,16H, 00H,00H,32H
	  DB	00H,00H,64H, 00H,01H,28H
          DB    00H,02H,56H, 00H,05H,12H
	  DB    00H,10H,24H, 00H,20H,48H
          DB    00H,40H,96H, 00H,81H,92H
	  DB	01H,63H,84H, 03H,27H,68H

iBCD:;- Accumultor = BCD(Low_Word_of_Accumultor), A= most char
BCD0:
BCD1:
BCD2:
BCD3:
        ;-----Clear work area
	MOV	A, RecPtr
	ADD	A,#3
	MOV	RecLowByte,A
        MOV     W0,#0
        MOV     W1,#0
        MOV     W2,#0
        MOV     BitCounter, #16
        MOV     DPTR, #TblStart
BCDLoop:;-------Get current bit
        MOV     A, RecLowByte
        MOV     Wptr, A
        MOV     A,@WPtr
        RLC     A
        MOV     @WPtr,A
        DEC     WPtr
        MOV     A,@WPtr
        RLC     A
        MOV     @WPtr,A
        JNC     OverAdd
        ;------- Add with DAA some constant to Low.RecWord
        MOV     A, BitCounter; define index of TblStart
	MOV	B, #3
	MUL 	AB
        DEC     A; index= 3*bitCounter - 1
        MOV     Wptr, A
        MOVC    A, @A+DPTR ; low digit
        ADD     A, W0
        DA      A
        MOV     W0,A
        DEC     Wptr
        MOV     A, Wptr
        MOVC    A, @A+DPTR ; high digit
        ADDC    A, W1
        DA      A
        MOV     W1,A
        DEC     Wptr
        MOV     A, Wptr
        MOVC    A, @A+DPTR ; high digit
        ADDC    A, W2
        MOV     W2,A ; over digit
OverAdd:
        DJNZ    BitCounter, BCDLoop
        ;--- ASCII conversion and put into Rec
        MOV     A, W1
        SWAP    A
        %Convert(@RecPtr)
        INC     RecPtr
        MOV     A, W1
        %Convert(@RecPtr)
        INC     RecPtr
        MOV     A, W0
        SWAP    A
        %Convert(@RecPtr)
        INC     RecPtr
        MOV     A, W0
        %Convert(@RecPtr)
        MOV     A, W2
        %Convert(WPtr)
        MOV     A, Wptr
        RET

        END
