        NAME    MiscMOD
;-------- Miscellaneous operations follow.

        PUBLIC  iCLEAR             ; for assembler
        PUBLIC  CLEAR0, ?CLEAR0?Byte ; for PLMs
        PUBLIC  CLEAR1, ?CLEAR1?Byte
        PUBLIC  CLEAR2, ?CLEAR2?Byte
        PUBLIC  CLEAR3, ?CLEAR3?Byte
        PUBLIC  iABS             ; for assembler
        PUBLIC  ABS0, ?ABS0?Byte ; for PLMs
        PUBLIC  ABS1, ?ABS1?Byte
        PUBLIC  ABS2, ?ABS2?Byte
        PUBLIC  ABS3, ?ABS3?Byte
        PUBLIC  iINVERT             ; for assembler
        PUBLIC  INVERT0, ?INVERT0?Byte ; for PLMs
        PUBLIC  INVERT1, ?INVERT1?Byte
        PUBLIC  INVERT2, ?INVERT2?Byte
        PUBLIC  INVERT3, ?INVERT3?Byte
        PUBLIC  iPUT             ; for assembler
        PUBLIC  PUT0, ?PUT0?Byte ; for PLMs
        PUBLIC  PUT1, ?PUT1?Byte
        PUBLIC  PUT2, ?PUT2?Byte
        PUBLIC  PUT3, ?PUT3?Byte


?CLEAR0?Byte EQU 1;  uses bank 0!  Start from R1 etc.
?CLEAR1?Byte EQU 9;  uses bank 1!  Start from R1 etc.
?CLEAR2?Byte EQU 17; uses bank 2!  Start from R1 etc.
?CLEAR3?Byte EQU 25; uses bank 3!  Start from R1 etc.
?INVERT0?Byte EQU 1; uses bank 0!  Start from R1 etc.
?INVERT1?Byte EQU 9; uses bank 1!  Start from R1 etc.
?INVERT2?Byte EQU 17;uses bank 2!  Start from R1 etc.
?INVERT3?Byte EQU 25;uses bank 3!  Start from R1 etc.
?ABS0?Byte EQU 1;    uses bank 0!  Start from R1 etc.
?ABS1?Byte EQU 9;    uses bank 1!  Start from R1 etc.
?ABS2?Byte EQU 17;   uses bank 2!  Start from R1 etc.
?ABS3?Byte EQU 25;   uses bank 3!  Start from R1 etc.
?PUT0?Byte EQU 1;    uses bank 0!  Start from R1 etc.
?PUT1?Byte EQU 9;    uses bank 1!  Start from R1 etc.
?PUT2?Byte EQU 17;   uses bank 2!  Start from R1 etc.
?PUT3?Byte EQU 25;   uses bank 3!  Start from R1 etc.

RecPtr  EQU     R1
Count   EQU     R6
Index	EQU	R0

        Math2   SEGMENT CODE
        RSEG    Math2
iCLEAR:;--------  CLEAR(Record)= 00,00,00,00
CLEAR0:
CLEAR1:
CLEAR2:
CLEAR3:
       MOV      Count, #4
       MOV      A, RecPtr
       MOV      Index, A
       CLR      A
CLRloop:
       MOV      @Index, A
       INC      Index
       DJNZ     Count, CLRloop
       RET


iINVERT:;--INVERT(Record)= 00,00,00,01 --> FF,FF,FF,FF
INVERT0:
INVERT1:
INVERT2:
INVERT3:
       MOV      Count, #4
       MOV      A, RecPtr
       ADD      A, #3
       MOV      RecPtr, A
       MOV      R7, #1
       CLR      CY
INVloop:
       MOV      A, @RecPtr
       CPL      A
       ADDC     A, R7
       MOV      @RecPtr, A
       DEC      RecPtr
       MOV      R7, #0
       DJNZ     Count, INVloop
       INC      RecPtr
       RET


iABS:;-- ABS(Record), CY= minus,  FF,FF,FF,FF-->00,00,00,01 and CY=1
ABS0:;          if the most bit=1 then negative value
ABS1:
ABS2:
ABS3:
        MOV     A, @RecPTR; high byte
        CLR     F0; Default '+' sign
        JNB     ACC.7, EscABS
        SETB    F0
        LCALL   iINVERT
EscABS: MOV     C, F0
        RET


iPUT:;--PUT(Record)= R2,R3,R4,R5
PUT0:
PUT1:
PUT2:
PUT3:
       MOV      A, RecPtr
       ADD      A, #3
       MOV      RecPtr, A
       MOV      A,R5
       MOV      @RecPtr, A
       DEC      RecPtr
       MOV      A,R4
       MOV      @RecPtr, A
       DEC      RecPtr
       MOV      A,R3
       MOV      @RecPtr, A
       DEC      RecPtr
       MOV      A,R2
       MOV      @RecPtr, A
       RET

        END
